# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ihmc_msgs/EndEffectorLoadBearingRosMessage.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class EndEffectorLoadBearingRosMessage(genpy.Message):
  _md5sum = "73629b50c5864d7b644ccb86fc00d128"
  _type = "ihmc_msgs/EndEffectorLoadBearingRosMessage"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """## EndEffectorLoadBearingRosMessage
# This message commands the controller to start loading an end effector that was unloaded to support
# the robot weight.  One application is making a foot loadbearing. When the robot is performing a
# 'flamingo stance' (one foot in the air not actually walking) and the user wants the robot to switch
# back to double support. A message with a unique id equals to 0 will be interpreted as invalid and
# will not be processed by the controller.

# Needed to identify a side dependent end-effector.
uint8 robot_side

# Specifies which end-effector should be loaded/unloaded.
uint8 end_effector

# Wether the end-effector should be loaded or unloaded.
uint8 request

# A unique id for the current message. This can be a timestamp or sequence number. Only the unique id
# in the top level message is used, the unique id in nested messages is ignored. Use
# /output/last_received_message for feedback about when the last message was received. A message with
# a unique id equals to 0 will be interpreted as invalid and will not be processed by the controller.
int64 unique_id


# This message utilizes "enums". Enum value information for this message follows.

# "robot_side" enum values:
uint8 LEFT=0 # refers to the LEFT side of a robot
uint8 RIGHT=1 # refers to the RIGHT side of a robot

# "end_effector" enum values:
uint8 FOOT=0 # In this case, the user also needs to provide the robotSide. If in the air, the corresponding foot will enter first a vertical ground approach transition and eventually touch the ground and switch to loadbearing. Then the robot is ready to walk. It is preferable to request a foot to switch to load bearing when it is aready close to the ground.
uint8 HAND=1 # In this case, the user also needs to provide the robotSide. It is preferable to request a hand to switch to load bearing when it is aready close to the ground.

# "load_bearing_request" enum values:
uint8 LOAD=0 # Request to load the given end-effector.
uint8 UNLOAD=1 # Request to unload the given end-effector.

"""
  # Pseudo-constants
  LEFT = 0
  RIGHT = 1
  FOOT = 0
  HAND = 1
  LOAD = 0
  UNLOAD = 1

  __slots__ = ['robot_side','end_effector','request','unique_id']
  _slot_types = ['uint8','uint8','uint8','int64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       robot_side,end_effector,request,unique_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EndEffectorLoadBearingRosMessage, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.robot_side is None:
        self.robot_side = 0
      if self.end_effector is None:
        self.end_effector = 0
      if self.request is None:
        self.request = 0
      if self.unique_id is None:
        self.unique_id = 0
    else:
      self.robot_side = 0
      self.end_effector = 0
      self.request = 0
      self.unique_id = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3Bq.pack(_x.robot_side, _x.end_effector, _x.request, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      _x = self
      start = end
      end += 11
      (_x.robot_side, _x.end_effector, _x.request, _x.unique_id,) = _struct_3Bq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3Bq.pack(_x.robot_side, _x.end_effector, _x.request, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 11
      (_x.robot_side, _x.end_effector, _x.request, _x.unique_id,) = _struct_3Bq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3Bq = struct.Struct("<3Bq")
