# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ihmc_msgs/FootstepDataListRosMessage.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import ihmc_msgs.msg

class FootstepDataListRosMessage(genpy.Message):
  _md5sum = "4a4566009cfa3ecc97d3d4b54299c4cc"
  _type = "ihmc_msgs/FootstepDataListRosMessage"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """## FootstepDataListRosMessage
# This message commands the controller to execute a list of footsteps. See FootstepDataMessage for
# information about defining a footstep. A message with a unique id equals to 0 will be interpreted as
# invalid and will not be processed by the controller. This rule does not apply to the fields of this
# message.

# Defines the list of footstep to perform.
ihmc_msgs/FootstepDataRosMessage[] footstep_data_list

# When OVERRIDE is chosen:  - All previously sent footstep lists will be overriden, regardless of
# their execution mode  - A footstep can be overridden up to end of transfer. Once the swing foot
# leaves the ground it cannot be overridden  When QUEUE is chosen:  This footstep list will be queued
# with previously sent footstep lists, regardless of their execution mode  - The trajectory time and
# swing time of all queued footsteps will be overwritten with this message's values.
uint8 execution_mode

# swingTime is the time spent in single-support when stepping  - Queueing does not support varying
# swing times. If execution mode is QUEUE, all queued footsteps' swingTime will be overwritten  - The
# value can be overwritten by specifying a swing time in the FootstepDataMessage for each individual
# step.
float64 default_swing_time

# transferTime is the time spent in double-support between steps  - Queueing does not support varying
# transfer times. If execution mode is QUEUE, all queued footsteps' transferTime will be overwritten 
# - The value can be overwritten by specifying a transfer time in the FootstepDataMessage for each
# individual step.
float64 default_transfer_time

# Specifies the transfer time to go to standing after the execution of the footstep list is finished.
# If the value is negative the defaultTransfer time will be used.
float64 final_transfer_time

# A unique id for the current message. This can be a timestamp or sequence number. Only the unique id
# in the top level message is used, the unique id in nested messages is ignored. Use
# /output/last_received_message for feedback about when the last message was received. A message with
# a unique id equals to 0 will be interpreted as invalid and will not be processed by the controller.
int64 unique_id


# This message utilizes "enums". Enum value information for this message follows.

# "execution_mode" enum values:
uint8 OVERRIDE=0 # This message will override the previous.
uint8 QUEUE=1 # The previous message will first be executed before executing this message. When sending a series of queued messages, the very first has to be declared as OVERRIDE.


================================================================================
MSG: ihmc_msgs/FootstepDataRosMessage
## FootstepDataRosMessage
# This message specifies the position, orientation and side (left or right) of a desired footstep in
# world frame.

# Specifies whether the given location is the location of the ankle or the sole.
uint8 origin

# Specifies which foot will swing to reach the foostep.
uint8 robot_side

# Specifies the position of the footstep. It is expressed in world frame.
geometry_msgs/Vector3 location

# Specifies the orientation of the footstep. It is expressed in world frame.
geometry_msgs/Quaternion orientation

# predictedContactPoints specifies the vertices of the expected contact polygon between the foot and
# the world. A value of null or an empty list will default to using the entire foot. Contact points 
# are expressed in sole frame. This ordering does not matter. For example: to tell the controller to
# use the entire foot, the predicted contact points would be: predicted_contact_points: - {x: 0.5 *
# foot_length, y: -0.5 * toe_width} - {x: 0.5 * foot_length, y: 0.5 * toe_width} - {x: -0.5 *
# foot_length, y: -0.5 * heel_width} - {x: -0.5 * foot_length, y: 0.5 * heel_width} 
ihmc_msgs/Point2dRosMessage[] predicted_contact_points

# This contains information on what the swing trajectory should be for each step. Recomended is
# DEFAULT. 
uint8 trajectory_type

# In case the trajectory type is set to custom the swing waypoints can be specified here (As of Dec
# 2016 only two waypoints are supported). The waypoints specify the sole position in the world frame.
geometry_msgs/Vector3[] trajectory_waypoints

# Contains information on how high the robot should step. This affects trajectory types default and
# obstacle clearance.Recommended values are between 0.1 (minimum swing height, default) and 0.25. 
float64 swing_height

# Boolean that determines whether the controller should use swing and transfer times specifies in this
# message (if true) orif the default swing and transfer times from the FootstepDataListMessage should
# be used (if false).
bool has_timings

# Specifies the swing time for this footstep.
float64 swing_time

# Specifies the transfer time before this step.
float64 transfer_time

# Boolean that determines whether the controller should attemp at keeping absolute timings for the
# execution of this footstep. This means that a time for foot lift-off (end of toe off) needs to be
# specified. The timing is set with respect to the start of the execution of the FootstepDataList that
# this footstep is part of.
bool has_absolute_time

# If using absolute timings this is the time at which the controller will start the swing. The time is
# with respect to the time at which the controller recieves the walking command. The value of this
# time must be increasing throughout a FootstepDataListMessage, otherwise it is ignored.
float64 swing_start_time

# A unique id for the current message. This can be a timestamp or sequence number. Only the unique id
# in the top level message is used, the unique id in nested messages is ignored. Use
# /output/last_received_message for feedback about when the last message was received. A message with
# a unique id equals to 0 will be interpreted as invalid and will not be processed by the controller.
int64 unique_id


# This message utilizes "enums". Enum value information for this message follows.

# "robot_side" enum values:
uint8 LEFT=0 # refers to the LEFT side of a robot
uint8 RIGHT=1 # refers to the RIGHT side of a robot

# "footstep_origin" enum values:
uint8 AT_ANKLE_FRAME=0 # The location of the footstep refers to the location of the ankle frame. The ankle frame is fixed in the foot, centered at the last ankle joint. The orientation = [qx = 0.0, qy = 0.0, qz = 0.0, qs = 1.0] corresponds to: x-axis pointing forward, y-axis pointing left, z-axis pointing upward. This option is for backward compatibility only and will be gone in an upcoming release. This origin is deprecated as it directly depends on the robot structure and is not directly related to the actual foot sole.
uint8 AT_SOLE_FRAME=1 # The location of the footstep refers to the location of the sole frame. The sole frame is fixed in the foot, centered at the center of the sole. The orientation = [qx = 0.0, qy = 0.0, qz = 0.0, qs = 1.0] corresponds to: x-axis pointing forward, y-axis pointing left, z-axis pointing upward. This origin is preferred as it directly depends on the actual foot sole and is less dependent on the robot structure.

# "trajectory_type" enum values:
uint8 DEFAULT=0 # is a default trajectory
uint8 OBSTACLE_CLEARANCE=1 # will attempt to step over an obstacle
uint8 CUSTOM=2 # allows to specify trajectory waypoints


================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: ihmc_msgs/Point2dRosMessage
## Point2dRosMessage
# This message represents a point on a 2d plane. The coordinates are referred to as "x" and "y"
# The first coordinate of the point in a 2D plane
float64 x

# The second coordinate of the point in a 2D plane
float64 y

"""
  # Pseudo-constants
  OVERRIDE = 0
  QUEUE = 1

  __slots__ = ['footstep_data_list','execution_mode','default_swing_time','default_transfer_time','final_transfer_time','unique_id']
  _slot_types = ['ihmc_msgs/FootstepDataRosMessage[]','uint8','float64','float64','float64','int64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       footstep_data_list,execution_mode,default_swing_time,default_transfer_time,final_transfer_time,unique_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(FootstepDataListRosMessage, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.footstep_data_list is None:
        self.footstep_data_list = []
      if self.execution_mode is None:
        self.execution_mode = 0
      if self.default_swing_time is None:
        self.default_swing_time = 0.
      if self.default_transfer_time is None:
        self.default_transfer_time = 0.
      if self.final_transfer_time is None:
        self.final_transfer_time = 0.
      if self.unique_id is None:
        self.unique_id = 0
    else:
      self.footstep_data_list = []
      self.execution_mode = 0
      self.default_swing_time = 0.
      self.default_transfer_time = 0.
      self.final_transfer_time = 0.
      self.unique_id = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.footstep_data_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.footstep_data_list:
        _x = val1
        buff.write(_struct_2B.pack(_x.origin, _x.robot_side))
        _v1 = val1.location
        _x = _v1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v2 = val1.orientation
        _x = _v2
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.predicted_contact_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.predicted_contact_points:
          _x = val2
          buff.write(_struct_2d.pack(_x.x, _x.y))
        buff.write(_struct_B.pack(val1.trajectory_type))
        length = len(val1.trajectory_waypoints)
        buff.write(_struct_I.pack(length))
        for val2 in val1.trajectory_waypoints:
          _x = val2
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_struct_dB2dBdq.pack(_x.swing_height, _x.has_timings, _x.swing_time, _x.transfer_time, _x.has_absolute_time, _x.swing_start_time, _x.unique_id))
      _x = self
      buff.write(_struct_B3dq.pack(_x.execution_mode, _x.default_swing_time, _x.default_transfer_time, _x.final_transfer_time, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.footstep_data_list is None:
        self.footstep_data_list = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.footstep_data_list = []
      for i in range(0, length):
        val1 = ihmc_msgs.msg.FootstepDataRosMessage()
        _x = val1
        start = end
        end += 2
        (_x.origin, _x.robot_side,) = _struct_2B.unpack(str[start:end])
        _v3 = val1.location
        _x = _v3
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v4 = val1.orientation
        _x = _v4
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.predicted_contact_points = []
        for i in range(0, length):
          val2 = ihmc_msgs.msg.Point2dRosMessage()
          _x = val2
          start = end
          end += 16
          (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
          val1.predicted_contact_points.append(val2)
        start = end
        end += 1
        (val1.trajectory_type,) = _struct_B.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.trajectory_waypoints = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Vector3()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          val1.trajectory_waypoints.append(val2)
        _x = val1
        start = end
        end += 42
        (_x.swing_height, _x.has_timings, _x.swing_time, _x.transfer_time, _x.has_absolute_time, _x.swing_start_time, _x.unique_id,) = _struct_dB2dBdq.unpack(str[start:end])
        val1.has_timings = bool(val1.has_timings)
        val1.has_absolute_time = bool(val1.has_absolute_time)
        self.footstep_data_list.append(val1)
      _x = self
      start = end
      end += 33
      (_x.execution_mode, _x.default_swing_time, _x.default_transfer_time, _x.final_transfer_time, _x.unique_id,) = _struct_B3dq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.footstep_data_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.footstep_data_list:
        _x = val1
        buff.write(_struct_2B.pack(_x.origin, _x.robot_side))
        _v5 = val1.location
        _x = _v5
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v6 = val1.orientation
        _x = _v6
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.predicted_contact_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.predicted_contact_points:
          _x = val2
          buff.write(_struct_2d.pack(_x.x, _x.y))
        buff.write(_struct_B.pack(val1.trajectory_type))
        length = len(val1.trajectory_waypoints)
        buff.write(_struct_I.pack(length))
        for val2 in val1.trajectory_waypoints:
          _x = val2
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_struct_dB2dBdq.pack(_x.swing_height, _x.has_timings, _x.swing_time, _x.transfer_time, _x.has_absolute_time, _x.swing_start_time, _x.unique_id))
      _x = self
      buff.write(_struct_B3dq.pack(_x.execution_mode, _x.default_swing_time, _x.default_transfer_time, _x.final_transfer_time, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.footstep_data_list is None:
        self.footstep_data_list = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.footstep_data_list = []
      for i in range(0, length):
        val1 = ihmc_msgs.msg.FootstepDataRosMessage()
        _x = val1
        start = end
        end += 2
        (_x.origin, _x.robot_side,) = _struct_2B.unpack(str[start:end])
        _v7 = val1.location
        _x = _v7
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v8 = val1.orientation
        _x = _v8
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.predicted_contact_points = []
        for i in range(0, length):
          val2 = ihmc_msgs.msg.Point2dRosMessage()
          _x = val2
          start = end
          end += 16
          (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
          val1.predicted_contact_points.append(val2)
        start = end
        end += 1
        (val1.trajectory_type,) = _struct_B.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.trajectory_waypoints = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Vector3()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          val1.trajectory_waypoints.append(val2)
        _x = val1
        start = end
        end += 42
        (_x.swing_height, _x.has_timings, _x.swing_time, _x.transfer_time, _x.has_absolute_time, _x.swing_start_time, _x.unique_id,) = _struct_dB2dBdq.unpack(str[start:end])
        val1.has_timings = bool(val1.has_timings)
        val1.has_absolute_time = bool(val1.has_absolute_time)
        self.footstep_data_list.append(val1)
      _x = self
      start = end
      end += 33
      (_x.execution_mode, _x.default_swing_time, _x.default_transfer_time, _x.final_transfer_time, _x.unique_id,) = _struct_B3dq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_B = struct.Struct("<B")
_struct_B3dq = struct.Struct("<B3dq")
_struct_2d = struct.Struct("<2d")
_struct_dB2dBdq = struct.Struct("<dB2dBdq")
_struct_2B = struct.Struct("<2B")
_struct_4d = struct.Struct("<4d")
_struct_3d = struct.Struct("<3d")
