# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ihmc_msgs/FootstepStatusRosMessage.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class FootstepStatusRosMessage(genpy.Message):
  _md5sum = "24833d6e588d22c48d116a3ce7c433d9"
  _type = "ihmc_msgs/FootstepStatusRosMessage"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """## FootstepStatusRosMessage
# This message gives the status of the current footstep from the controller as well as the position
# and orientation of the footstep in world cooredinates. 

# The current footstep status enum value.
uint8 status

# footstepIndex starts at 0 and monotonically increases with each completed footstep in a given
# FootstepDataListMessage.
int32 footstep_index

# The robot side (left or right) that this footstep status correlates to.
uint8 robot_side

# desiredFootPositionInWorld gives the position of the desired position sent to the controller as
# opposed to where the foot actually landed
geometry_msgs/Vector3 desired_foot_position_in_world

# desiredFootOrientationInWorld gives the desired orientation of the foot sent to the controller as
# opposed to the orientation where the foot actually is
geometry_msgs/Quaternion desired_foot_orientation_in_world

# actualFootPositionInWorld gives the position of where the foot actually landed as opposed to the
# desired position sent to the controller
geometry_msgs/Vector3 actual_foot_position_in_world

# actualFootOrientationInWorld gives the orientation the foot is actually in as opposed to the desired
# orientation sent to the controller
geometry_msgs/Quaternion actual_foot_orientation_in_world

# A unique id for the current message. This can be a timestamp or sequence number. Only the unique id
# in the top level message is used, the unique id in nested messages is ignored. Use
# /output/last_received_message for feedback about when the last message was received. A message with
# a unique id equals to 0 will be interpreted as invalid and will not be processed by the controller.
int64 unique_id


# This message utilizes "enums". Enum value information for this message follows.

# "status" enum values:
uint8 STARTED=0 # execution of a footstep has begun. actualFootPositionInWorld and actualFootOrientationInWorld should be ignored in this state
uint8 COMPLETED=1 # a footstep is completed

# "robot_side" enum values:
uint8 LEFT=0 # refers to the LEFT side of a robot
uint8 RIGHT=1 # refers to the RIGHT side of a robot


================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  # Pseudo-constants
  STARTED = 0
  COMPLETED = 1
  LEFT = 0
  RIGHT = 1

  __slots__ = ['status','footstep_index','robot_side','desired_foot_position_in_world','desired_foot_orientation_in_world','actual_foot_position_in_world','actual_foot_orientation_in_world','unique_id']
  _slot_types = ['uint8','int32','uint8','geometry_msgs/Vector3','geometry_msgs/Quaternion','geometry_msgs/Vector3','geometry_msgs/Quaternion','int64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       status,footstep_index,robot_side,desired_foot_position_in_world,desired_foot_orientation_in_world,actual_foot_position_in_world,actual_foot_orientation_in_world,unique_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(FootstepStatusRosMessage, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.status is None:
        self.status = 0
      if self.footstep_index is None:
        self.footstep_index = 0
      if self.robot_side is None:
        self.robot_side = 0
      if self.desired_foot_position_in_world is None:
        self.desired_foot_position_in_world = geometry_msgs.msg.Vector3()
      if self.desired_foot_orientation_in_world is None:
        self.desired_foot_orientation_in_world = geometry_msgs.msg.Quaternion()
      if self.actual_foot_position_in_world is None:
        self.actual_foot_position_in_world = geometry_msgs.msg.Vector3()
      if self.actual_foot_orientation_in_world is None:
        self.actual_foot_orientation_in_world = geometry_msgs.msg.Quaternion()
      if self.unique_id is None:
        self.unique_id = 0
    else:
      self.status = 0
      self.footstep_index = 0
      self.robot_side = 0
      self.desired_foot_position_in_world = geometry_msgs.msg.Vector3()
      self.desired_foot_orientation_in_world = geometry_msgs.msg.Quaternion()
      self.actual_foot_position_in_world = geometry_msgs.msg.Vector3()
      self.actual_foot_orientation_in_world = geometry_msgs.msg.Quaternion()
      self.unique_id = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_BiB14dq.pack(_x.status, _x.footstep_index, _x.robot_side, _x.desired_foot_position_in_world.x, _x.desired_foot_position_in_world.y, _x.desired_foot_position_in_world.z, _x.desired_foot_orientation_in_world.x, _x.desired_foot_orientation_in_world.y, _x.desired_foot_orientation_in_world.z, _x.desired_foot_orientation_in_world.w, _x.actual_foot_position_in_world.x, _x.actual_foot_position_in_world.y, _x.actual_foot_position_in_world.z, _x.actual_foot_orientation_in_world.x, _x.actual_foot_orientation_in_world.y, _x.actual_foot_orientation_in_world.z, _x.actual_foot_orientation_in_world.w, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.desired_foot_position_in_world is None:
        self.desired_foot_position_in_world = geometry_msgs.msg.Vector3()
      if self.desired_foot_orientation_in_world is None:
        self.desired_foot_orientation_in_world = geometry_msgs.msg.Quaternion()
      if self.actual_foot_position_in_world is None:
        self.actual_foot_position_in_world = geometry_msgs.msg.Vector3()
      if self.actual_foot_orientation_in_world is None:
        self.actual_foot_orientation_in_world = geometry_msgs.msg.Quaternion()
      end = 0
      _x = self
      start = end
      end += 126
      (_x.status, _x.footstep_index, _x.robot_side, _x.desired_foot_position_in_world.x, _x.desired_foot_position_in_world.y, _x.desired_foot_position_in_world.z, _x.desired_foot_orientation_in_world.x, _x.desired_foot_orientation_in_world.y, _x.desired_foot_orientation_in_world.z, _x.desired_foot_orientation_in_world.w, _x.actual_foot_position_in_world.x, _x.actual_foot_position_in_world.y, _x.actual_foot_position_in_world.z, _x.actual_foot_orientation_in_world.x, _x.actual_foot_orientation_in_world.y, _x.actual_foot_orientation_in_world.z, _x.actual_foot_orientation_in_world.w, _x.unique_id,) = _struct_BiB14dq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_BiB14dq.pack(_x.status, _x.footstep_index, _x.robot_side, _x.desired_foot_position_in_world.x, _x.desired_foot_position_in_world.y, _x.desired_foot_position_in_world.z, _x.desired_foot_orientation_in_world.x, _x.desired_foot_orientation_in_world.y, _x.desired_foot_orientation_in_world.z, _x.desired_foot_orientation_in_world.w, _x.actual_foot_position_in_world.x, _x.actual_foot_position_in_world.y, _x.actual_foot_position_in_world.z, _x.actual_foot_orientation_in_world.x, _x.actual_foot_orientation_in_world.y, _x.actual_foot_orientation_in_world.z, _x.actual_foot_orientation_in_world.w, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.desired_foot_position_in_world is None:
        self.desired_foot_position_in_world = geometry_msgs.msg.Vector3()
      if self.desired_foot_orientation_in_world is None:
        self.desired_foot_orientation_in_world = geometry_msgs.msg.Quaternion()
      if self.actual_foot_position_in_world is None:
        self.actual_foot_position_in_world = geometry_msgs.msg.Vector3()
      if self.actual_foot_orientation_in_world is None:
        self.actual_foot_orientation_in_world = geometry_msgs.msg.Quaternion()
      end = 0
      _x = self
      start = end
      end += 126
      (_x.status, _x.footstep_index, _x.robot_side, _x.desired_foot_position_in_world.x, _x.desired_foot_position_in_world.y, _x.desired_foot_position_in_world.z, _x.desired_foot_orientation_in_world.x, _x.desired_foot_orientation_in_world.y, _x.desired_foot_orientation_in_world.z, _x.desired_foot_orientation_in_world.w, _x.actual_foot_position_in_world.x, _x.actual_foot_position_in_world.y, _x.actual_foot_position_in_world.z, _x.actual_foot_orientation_in_world.x, _x.actual_foot_orientation_in_world.y, _x.actual_foot_orientation_in_world.z, _x.actual_foot_orientation_in_world.w, _x.unique_id,) = _struct_BiB14dq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_BiB14dq = struct.Struct("<BiB14dq")
