# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ihmc_msgs/GoHomeRosMessage.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class GoHomeRosMessage(genpy.Message):
  _md5sum = "f656bdcc5d04e0fce415fabaa1a8e028"
  _type = "ihmc_msgs/GoHomeRosMessage"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """## GoHomeRosMessage
# The message commands the controller to bring the given part of the body back to a default
# configuration called 'home'. It is useful to get back to a safe configuration before walking.

# Specifies the part of the body the user wants to move back to it home configuration.
uint8 body_part

# Needed to identify a side dependent end-effector.
uint8 robot_side

# How long the trajectory will spline from the current desired to the home configuration.
float64 trajectory_time

# A unique id for the current message. This can be a timestamp or sequence number. Only the unique id
# in the top level message is used, the unique id in nested messages is ignored. Use
# /output/last_received_message for feedback about when the last message was received. A message with
# a unique id equals to 0 will be interpreted as invalid and will not be processed by the controller.
int64 unique_id


# This message utilizes "enums". Enum value information for this message follows.

# "robot_side" enum values:
uint8 LEFT=0 # refers to the LEFT side of a robot
uint8 RIGHT=1 # refers to the RIGHT side of a robot

# "body_part" enum values:
uint8 ARM=0 # Request the chest to go back to a straight up configuration.
uint8 CHEST=1 # Request the arm to go to a preconfigured home configuration that is elbow lightly flexed, forearm pointing forward, and upper pointing downward.
uint8 PELVIS=2 # Request the pelvis to go back to between the feet, zero pitch and roll, and headed in the same direction as the feet.

"""
  # Pseudo-constants
  LEFT = 0
  RIGHT = 1
  ARM = 0
  CHEST = 1
  PELVIS = 2

  __slots__ = ['body_part','robot_side','trajectory_time','unique_id']
  _slot_types = ['uint8','uint8','float64','int64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       body_part,robot_side,trajectory_time,unique_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GoHomeRosMessage, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.body_part is None:
        self.body_part = 0
      if self.robot_side is None:
        self.robot_side = 0
      if self.trajectory_time is None:
        self.trajectory_time = 0.
      if self.unique_id is None:
        self.unique_id = 0
    else:
      self.body_part = 0
      self.robot_side = 0
      self.trajectory_time = 0.
      self.unique_id = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2Bdq.pack(_x.body_part, _x.robot_side, _x.trajectory_time, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      _x = self
      start = end
      end += 18
      (_x.body_part, _x.robot_side, _x.trajectory_time, _x.unique_id,) = _struct_2Bdq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2Bdq.pack(_x.body_part, _x.robot_side, _x.trajectory_time, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 18
      (_x.body_part, _x.robot_side, _x.trajectory_time, _x.unique_id,) = _struct_2Bdq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2Bdq = struct.Struct("<2Bdq")
