# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ihmc_msgs/HandDesiredConfigurationRosMessage.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class HandDesiredConfigurationRosMessage(genpy.Message):
  _md5sum = "06ee4472791eaf16119740f0672d6905"
  _type = "ihmc_msgs/HandDesiredConfigurationRosMessage"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """## HandDesiredConfigurationRosMessage
# Packet for commanding the hands to perform various predefined grasps. A message with a unique id
# equals to 0 will be interpreted as invalid and will not be processed by the controller.

# Specifies the side of the robot that will execute the trajectory
uint8 robot_side

# Specifies the grasp to perform
uint8 hand_desired_configuration

# A unique id for the current message. This can be a timestamp or sequence number. Only the unique id
# in the top level message is used, the unique id in nested messages is ignored. Use
# /output/last_received_message for feedback about when the last message was received. A message with
# a unique id equals to 0 will be interpreted as invalid and will not be processed by the controller.
int64 unique_id


# This message utilizes "enums". Enum value information for this message follows.

# "hand_configuration" enum values:
uint8 STOP=0 # stops the fingers at their current position
uint8 OPEN=1 # fully opens the fingers
uint8 CLOSE=2 # fully closes the fingers
uint8 CRUSH=3 # fully closes the fingers applying maximum force
uint8 HOOK=4 # closes all but one finger to create a hook
uint8 BASIC_GRIP=5 # sets gripper to use a standard grasp
uint8 PINCH_GRIP=6 # sets gripper to use a pinch grasp where the thumb and fingers come together when closed
uint8 WIDE_GRIP=7 # sets gripper to use a wide-spread finger grasp
uint8 SCISSOR_GRIP=8 # sets gripper to use a scissor grasp where the index and middle finger come together when closed
uint8 RESET=9 # sets all fingers to their zero position
uint8 OPEN_FINGERS=10 # fully open all fingers except the thumb
uint8 OPEN_THUMB=11 # fully open the thumb only
uint8 CLOSE_FINGERS=12 # fully close all fingers except the thumb
uint8 CLOSE_THUMB=13 # fully close the thumb only

# "robot_side" enum values:
uint8 LEFT=0 # refers to the LEFT side of a robot
uint8 RIGHT=1 # refers to the RIGHT side of a robot

"""
  # Pseudo-constants
  STOP = 0
  OPEN = 1
  CLOSE = 2
  CRUSH = 3
  HOOK = 4
  BASIC_GRIP = 5
  PINCH_GRIP = 6
  WIDE_GRIP = 7
  SCISSOR_GRIP = 8
  RESET = 9
  OPEN_FINGERS = 10
  OPEN_THUMB = 11
  CLOSE_FINGERS = 12
  CLOSE_THUMB = 13
  LEFT = 0
  RIGHT = 1

  __slots__ = ['robot_side','hand_desired_configuration','unique_id']
  _slot_types = ['uint8','uint8','int64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       robot_side,hand_desired_configuration,unique_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HandDesiredConfigurationRosMessage, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.robot_side is None:
        self.robot_side = 0
      if self.hand_desired_configuration is None:
        self.hand_desired_configuration = 0
      if self.unique_id is None:
        self.unique_id = 0
    else:
      self.robot_side = 0
      self.hand_desired_configuration = 0
      self.unique_id = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2Bq.pack(_x.robot_side, _x.hand_desired_configuration, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      _x = self
      start = end
      end += 10
      (_x.robot_side, _x.hand_desired_configuration, _x.unique_id,) = _struct_2Bq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2Bq.pack(_x.robot_side, _x.hand_desired_configuration, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 10
      (_x.robot_side, _x.hand_desired_configuration, _x.unique_id,) = _struct_2Bq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2Bq = struct.Struct("<2Bq")
