# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ihmc_msgs/HighLevelStateRosMessage.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class HighLevelStateRosMessage(genpy.Message):
  _md5sum = "28d016650e642f1a83b4064e072c8074"
  _type = "ihmc_msgs/HighLevelStateRosMessage"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """## HighLevelStateRosMessage
# This message is used to switch the control scheme between force and position control. WARNING: When
# in position control, the IHMC balance algorithms will be disabled and it is up to the user to ensure
# stability.

# The enum value of the current high level state of the robot.
uint8 high_level_state

# A unique id for the current message. This can be a timestamp or sequence number. Only the unique id
# in the top level message is used, the unique id in nested messages is ignored. Use
# /output/last_received_message for feedback about when the last message was received. A message with
# a unique id equals to 0 will be interpreted as invalid and will not be processed by the controller.
int64 unique_id


# This message utilizes "enums". Enum value information for this message follows.

# "high_level_state" enum values:
uint8 WALKING=0 # whole body force control employing IHMC walking, balance, and manipulation algorithms
uint8 DO_NOTHING_BEHAVIOR=1 # do nothing behavior. the robot will start in this behavior, and report this behavior when falling and ramping down the controller. This behavior is intended for feedback only. Requesting this behavior is not supported and can cause the robot to shut down.
uint8 DIAGNOSTICS=2 # The robot is peforming an automated diagnostic routine
uint8 CALIBRATION=3 # Automated calibration routine depending on the robot. For Valkyrie: estimation of the joint torque offsets.

"""
  # Pseudo-constants
  WALKING = 0
  DO_NOTHING_BEHAVIOR = 1
  DIAGNOSTICS = 2
  CALIBRATION = 3

  __slots__ = ['high_level_state','unique_id']
  _slot_types = ['uint8','int64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       high_level_state,unique_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HighLevelStateRosMessage, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.high_level_state is None:
        self.high_level_state = 0
      if self.unique_id is None:
        self.unique_id = 0
    else:
      self.high_level_state = 0
      self.unique_id = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_Bq.pack(_x.high_level_state, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.high_level_state, _x.unique_id,) = _struct_Bq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_Bq.pack(_x.high_level_state, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.high_level_state, _x.unique_id,) = _struct_Bq.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_Bq = struct.Struct("<Bq")
