# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ihmc_msgs/NeckDesiredAccelerationsRosMessage.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class NeckDesiredAccelerationsRosMessage(genpy.Message):
  _md5sum = "b2d02025b93b5ea34a928008a3ef4940"
  _type = "ihmc_msgs/NeckDesiredAccelerationsRosMessage"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """## NeckDesiredAccelerationsRosMessage
# This message gives the user the option to bypass IHMC feedback controllers for the neck joints by
# sending desired neck joint accelerations. One needs experience in control when activating the bypass
# as it can result in unexpected behaviors for unreasonable accelerations. A message with a unique id
# equals to 0 will be interpreted as invalid and will not be processed by the controller.

# Specifies the control mode for controlling the neck joints. See NeckControlMode.
uint8 neck_control_mode

# Specifies the desired joint accelerations. Only necessary when neckControlMode == USER_CONTROL_MODE.
float64[] neck_desired_joint_accelerations

# A unique id for the current message. This can be a timestamp or sequence number. Only the unique id
# in the top level message is used, the unique id in nested messages is ignored. Use
# /output/last_received_message for feedback about when the last message was received. A message with
# a unique id equals to 0 will be interpreted as invalid and will not be processed by the controller.
int64 unique_id


# This message utilizes "enums". Enum value information for this message follows.

# "neck_control_mode" enum values:
uint8 IHMC_CONTROL_MODE=0 # The IHMC controller controls the arm joints to execute desired inputs given from NeckTrajectoryMessage, HeadTrajectoryMessage. PD controllers are run for the given inputs and will either compute the desired head spatial acceleration or neck joint desired accelerations.The desired joint torques to achieve these desired accelerations are computed by the IHMC QP solver & inverse dynamics calculator.
uint8 USER_CONTROL_MODE=1 # The user directly sets what the neck joint desired accelerations have to be. The IHMC controller will stop tracking positions and the user desired accelerations will be fed to the IHMC QP solver & inverse dynamics to compute the desired joint torques.

"""
  # Pseudo-constants
  IHMC_CONTROL_MODE = 0
  USER_CONTROL_MODE = 1

  __slots__ = ['neck_control_mode','neck_desired_joint_accelerations','unique_id']
  _slot_types = ['uint8','float64[]','int64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       neck_control_mode,neck_desired_joint_accelerations,unique_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NeckDesiredAccelerationsRosMessage, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.neck_control_mode is None:
        self.neck_control_mode = 0
      if self.neck_desired_joint_accelerations is None:
        self.neck_desired_joint_accelerations = []
      if self.unique_id is None:
        self.unique_id = 0
    else:
      self.neck_control_mode = 0
      self.neck_desired_joint_accelerations = []
      self.unique_id = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_B.pack(self.neck_control_mode))
      length = len(self.neck_desired_joint_accelerations)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.neck_desired_joint_accelerations))
      buff.write(_struct_q.pack(self.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 1
      (self.neck_control_mode,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.neck_desired_joint_accelerations = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.unique_id,) = _struct_q.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_B.pack(self.neck_control_mode))
      length = len(self.neck_desired_joint_accelerations)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.neck_desired_joint_accelerations.tostring())
      buff.write(_struct_q.pack(self.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.neck_control_mode,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.neck_desired_joint_accelerations = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 8
      (self.unique_id,) = _struct_q.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_q = struct.Struct("<q")
_struct_B = struct.Struct("<B")
